/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package ije.exam1;

import java.util.HashSet;
import java.util.Set;
import org.junit.After;
import org.junit.AfterClass;
import org.junit.Before;
import org.junit.BeforeClass;
import org.junit.Test;
import static org.junit.Assert.*;

/**
 *
 * @author coki
 * Implement classes, methods, and constructors that satisfy following tests. The classes 
 * represent readers, authors, books, and library. Each book has its author, each author
 * can have more books. Readed can borrow and return some book. If this book is borrowed 
 * then nothing happens. Information about borrows and books are stored in the library.
 * It is also possible to get a set of book by given author.
 */
public class LibraryTest {

    public LibraryTest() {
    }

    @BeforeClass
    public static void setUpClass() throws Exception {
    }

    @AfterClass
    public static void tearDownClass() throws Exception {
    }

    @Before
    public void setUp() {
    }

    @After
    public void tearDown() {
    }
    
    @Test // 7 point
    public void test01() {
        Set<Author> as = new HashSet<Author>();
        Author a1 = new Author("Dickens");
        Author a2 = new Author("King");
        as.add(a1);
        as.add(a2);
        assertTrue(as.contains(new Author("Dickens")));
    }
    
    @Test // 10 points
    public void test02() {
        Author a1 = new Author("Charles Dickens");
        Author a2 = new Author("Stephen King");
        Book b1 = new Book(a1, "Little Dorrit");
        Book b2 = new Book(a1, "The Pickwick Papers");
        Book b3 = new Book(a2, "Firestarter");
        
        Library lib = new Library();
        lib.addBook(b1);
        lib.addBook(b2);
        lib.addBook(b3);

        Set<Book> books = lib.booksOfAuthorNamed("Charles Dickens");
        assertTrue(books.size() == 2);

        books = lib.booksOfAuthorNamed("Stephen King");
        assertTrue(books.size() == 1);
        books.contains(b3);

        books = lib.booksOfAuthorNamed("Frederick Forsyth");
        assertTrue(books.size() == 0);
    }
    
    @Test // 10 points
    public void test03() {
        Author a1 = new Author("Charles Dickens");
        Author a2 = new Author("Stephen King");
        Book b1 = new Book(a1, "Little Dorrit");
        Book b2 = new Book(a1, "The Pickwick Papers");
        Book b3 = new Book(a2, "Firestarter");
        
        Library lib = new Library();
        lib.addBook(b1);
        lib.addBook(b2);
        lib.addBook(b3);

        Reader r1 = new Reader("John", 1967);
        Reader r2 = new Reader("John", 1973);
        Reader r3 = new Reader("Adrien", 1973);
        
        assertTrue(lib.borrow(r1, b1));
        assertFalse(lib.borrow(r2, b1));
    }

    @Test // 10 points
    public void test04() {
        Author a1 = new Author("Charles Dickens");
        Book b1 = new Book(a1, "Little Dorrit");
        Book b2 = new Book(a1, "The Pickwick Papers");
        
        Library lib = new Library();
        lib.addBook(b1);
        lib.addBook(b2);

        Reader r1 = new Reader("John", 1967);
        
        lib.borrow(r1, b1);
        
        assertTrue(lib.returnBook(b1));
        assertFalse(lib.returnBook(b1));
    }

}